//+------------------------------------------------------------------+
//|                                                       Correl.mq4 |
//|                               Copyright  2007, Paramonov Andrey |
//|                              Indicator of Correl castom sysmbol  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Paramonov Andrey"
#property link      ""

#property indicator_chart_window

string  Base.Symbol;
extern string  S1.Name        = "EURUSD";
extern bool    S1.Allowed     = true;          
extern string  S2.Name        = "AUDUSD"; 
extern bool    S2.Allowed     = true;            
extern string  S3.Name        = "USDCHF";  
extern bool    S3.Allowed     = true;           
extern string  S4.Name        = "USDJPY";  
extern bool    S4.Allowed     = true;          
extern string  S5.Name        = "USDCAD";  
extern bool    S5.Allowed     = true;           
extern int     Correl.Period  =  14;


bool isOk = true;
string Com;
double S1.Correl,S2.Correl,S3.Correl,
       S4.Correl,S5.Correl;


int init()
  {  
    
      Base.Symbol = Symbol();
              //  . 
      if (iClose (Base.Symbol,0,Correl.Period)==0){
         Print (":    "+Base.Symbol);
         isOk = false;
         }
      if (S1.Allowed )
         if(iClose (S1.Name,0,Correl.Period)==0){
            Print (":    "+S1.Name);
            S1.Allowed = false;
         }   
      if (S2.Allowed )
         if(iClose (S2.Name,0,Correl.Period)==0){
            Print (":    "+S2.Name);
            S2.Allowed = false;
         }   
      if (S3.Allowed )
         if(iClose (S3.Name,0,Correl.Period)==0){
            Print (":    "+S3.Name);
            S3.Allowed = false;
         }   
      if (S4.Allowed )
         if(iClose (S4.Name,0,Correl.Period)==0){
            Print (":    "+S4.Name);
            S4.Allowed = false;
         }
      if (S5.Allowed )
         if(iClose (S5.Name,0,Correl.Period)==0){
            Print (":    "+S5.Name);
            S5.Allowed = false;
         }             
   return(0);
  }
int deinit()
  {
   
      Comment(""); 
   return(0);
   }
int start()
  {
   if (isOk)
   {
      
      if(S1.Allowed)S1.Correl=Correl(Base.Symbol,S1.Name);
      if(S2.Allowed)S2.Correl=Correl(Base.Symbol,S2.Name);         
      if(S3.Allowed)S3.Correl=Correl(Base.Symbol,S3.Name);         
      if(S4.Allowed)S4.Correl=Correl(Base.Symbol,S4.Name);         
      if(S5.Allowed)S5.Correl=Correl(Base.Symbol,S5.Name);
  
        
  
      Com="------------------------------------------\n";
      if(S1.Allowed)Com=Com+Base.Symbol+" vs "+S1.Name+" =  "+ DoubleToStr(S1.Correl,2)+"\n";
      if(S2.Allowed)Com=Com+Base.Symbol+" vs "+S2.Name+" =  "+ DoubleToStr(S2.Correl,2)+"\n";
      if(S3.Allowed)Com=Com+Base.Symbol+" vs "+S3.Name+" =  "+ DoubleToStr(S3.Correl,2)+"\n";
      if(S4.Allowed)Com=Com+Base.Symbol+" vs "+S4.Name+" =  "+ DoubleToStr(S4.Correl,2)+"\n";
      if(S5.Allowed)Com=Com+Base.Symbol+" vs "+S5.Name+" =  "+ DoubleToStr(S5.Correl,2)+"\n";
      Comment (Com);   
   }   
   return(0);
  }
double SymbolDif(string symbol, int shift)
  {
    return(iClose(symbol, 0, shift) - iMA(symbol, 0, Correl.Period, 0,MODE_SMA, 
           PRICE_CLOSE, shift));
  }

double PowDif(double val)
  {
   return(MathPow(val, 2));
  }

double U(double val1, double val2)
  {
   return((val1*val2));
  }

double Correl(string base, string hedge)
  {  
   double u1 = 0, l1 = 0, s1 = 0;
   for(int i = Correl.Period - 1; i >= 0; i--)
     {
       u1 += U(SymbolDif(base, i), SymbolDif(hedge, i));
       l1 += PowDif(SymbolDif(base, i));
       s1 += PowDif(SymbolDif(hedge, i));
     }
   double dMathSqrt = MathSqrt(l1*s1);
   if(dMathSqrt > 0) 
       return(u1 / dMathSqrt);
  }
    
 
  
   


